<!-- prettier-ignore-start -->
# Class OrderHooks

- [TopLevel.Object](TopLevel.Object.md)
  - [dw.order.hooks.OrderHooks](dw.order.hooks.OrderHooks.md)

This interface represents all script hooks that can be registered to customize the order logic. It contains the
extension points (hook names), and the functions that are called by each extension point. A function must be defined
inside a JavaScript source and must be exported. The script with the exported hook function must be located inside a
site cartridge. Inside the site cartridge a 'package.json' file with a 'hooks' entry must exist.


"hooks": "./hooks.json"


The hooks entry links to a json file, relative to the 'package.json' file. This file lists all registered hooks
inside the hooks property:




```
"hooks": [
   {"name": "dw.order.createOrderNo", "script": "./orders.ds"},
]
```



A hook entry has a 'name' and a 'script' property.

- The 'name' contains the extension point, the hook name.
- The 'script' contains the script relative to the hooks file, with the exported hook function.



## Constant Summary

| Constant | Description |
| --- | --- |
| [extensionPointCreateOrderNo](#extensionpointcreateorderno): [String](TopLevel.String.md) = "dw.order.createOrderNo" | The extension point name dw.order.createOrderNo. |

## Constructor Summary

This class does not have a constructor, so you cannot create it directly.
## Method Summary

| Method | Description |
| --- | --- |
| [createOrderNo](dw.order.hooks.OrderHooks.md#createorderno)() | This hook is responsible for creating a new order number. |

### Methods inherited from class Object

[assign](TopLevel.Object.md#assignobject-object), [create](TopLevel.Object.md#createobject), [create](TopLevel.Object.md#createobject-object), [defineProperties](TopLevel.Object.md#definepropertiesobject-object), [defineProperty](TopLevel.Object.md#definepropertyobject-object-object), [entries](TopLevel.Object.md#entriesobject), [freeze](TopLevel.Object.md#freezeobject), [fromEntries](TopLevel.Object.md#fromentriesiterable), [getOwnPropertyDescriptor](TopLevel.Object.md#getownpropertydescriptorobject-object), [getOwnPropertyNames](TopLevel.Object.md#getownpropertynamesobject), [getOwnPropertySymbols](TopLevel.Object.md#getownpropertysymbolsobject), [getPrototypeOf](TopLevel.Object.md#getprototypeofobject), [hasOwnProperty](TopLevel.Object.md#hasownpropertystring), [is](TopLevel.Object.md#isobject-object), [isExtensible](TopLevel.Object.md#isextensibleobject), [isFrozen](TopLevel.Object.md#isfrozenobject), [isPrototypeOf](TopLevel.Object.md#isprototypeofobject), [isSealed](TopLevel.Object.md#issealedobject), [keys](TopLevel.Object.md#keysobject), [preventExtensions](TopLevel.Object.md#preventextensionsobject), [propertyIsEnumerable](TopLevel.Object.md#propertyisenumerablestring), [seal](TopLevel.Object.md#sealobject), [setPrototypeOf](TopLevel.Object.md#setprototypeofobject-object), [toLocaleString](TopLevel.Object.md#tolocalestring), [toString](TopLevel.Object.md#tostring), [valueOf](TopLevel.Object.md#valueof), [values](TopLevel.Object.md#valuesobject)
## Constant Details

### extensionPointCreateOrderNo

- extensionPointCreateOrderNo: [String](TopLevel.String.md) = "dw.order.createOrderNo"
  - : The extension point name dw.order.createOrderNo.


---

## Method Details

### createOrderNo()
- createOrderNo(): [String](TopLevel.String.md)
  - : This hook is responsible for creating a new order number.
      
      
      By default order numbers are generated by using [OrderMgr.createOrderSequenceNo()](dw.order.OrderMgr.md#createordersequenceno). Use this hook
      to customize the order number generation. E.g. a prefix or suffix could be added.
      
      ```
      exports.createOrderNo = function(){
          var orderSeqNo = OrderMgr.createOrderSequenceNo();
          var prefix = Site.getCurrent().getSiteId();
          return prefix + "_"+orderSeqNo;
      };
      ```
      
      If the method returns `null` or an blank string order number generation will fall
      back to [OrderMgr.createOrderSequenceNo()](dw.order.OrderMgr.md#createordersequenceno).
      
      
      The maximum length of the order number is 50 characters.


    **Returns:**
    - the order number


---

<!-- prettier-ignore-end -->
